<template>
  <Page>
    <ElForm v-show="showSearchForm" inline @submit.prevent="paging">
      <ElFormItem label="角色代码">
        <ElInput
          v-model="searchForm.roleCode"
          placeholder="角色代码"/>
      </ElFormItem>
      <ElFormItem label="角色名称">
        <ElInput
          v-model="searchForm.roleName"
          placeholder="角色名称"/>
      </ElFormItem>
      <ElFormItem label="备注">
        <ElInput
          v-model="searchForm.memo"
          placeholder="备注"/>
      </ElFormItem>
      <ElFormItem>
        <ElButton :icon="elIcons.Search" :loading="searching" native-type="submit" type="primary">搜索</ElButton>
        <ElButton :icon="elIcons.Refresh" :loading="searching" @click="reset">重置</ElButton>
      </ElFormItem>
    </ElForm>
    <div class="tool-bar">
      <ElButton :icon="elIcons.Plus" type="primary" @click="addHandler">新建</ElButton>
      <ElButton :icon="elIcons.Filter" type="default" @click="showSearchForm = !showSearchForm"/>
    </div>
    <ElTable v-loading="searching" :data="tableData"
      cell-class-name="table-cell"
      class="table-list"
      empty-text="暂无数据"
      header-row-class-name="table-header"
      row-key="id">
      <ElTableColumn label="角色代码" prop="roleCode"/>

      <ElTableColumn label="角色名称" prop="roleName"/>

      <ElTableColumn label="备注" prop="memo"/>

      <ElTableColumn label="操作" width="180">
        <template #default="scope">
          <div class="action-btn">
            <ElPopconfirm
              v-if="scope.row.id != '1'"
              cancel-button-text="否"
              cancel-button-type="primary"
              confirm-button-text="是"
              confirm-button-type="danger"
              placement="top"
              title="是否删除当前数据?"
              width="180"
              @confirm="delHandler(scope)">
              <template #reference>
                <ElButton :loading="deling" text type="danger">删除</ElButton>
              </template>
            </ElPopconfirm>
            <ElButton text type="primary" @click="bindResHandler(scope)">资源</ElButton>
            <ElButton v-if="scope.row.id != '1'" text type="primary" @cl--ick="modifyHandler(scope)">修改</ElButton>
          </div>
        </template>
      </ElTableColumn>
    </ElTable>
    <ElPagination
      v-model:current-page="searchForm.current"
      v-model:page-size="searchForm.size"
      :hide-on-single-page="false"
      :page-sizes="[10, 20, 50, 100, 500]"
      :teleported="false"
      :total="totalCount"
      layout="->, sizes, total, prev, pager, next"
      @change="paging"/>
    <RoleForm ref="roleForm" @edit-succ="paging"/>
    <BindRes ref="bindRes"/>
  </Page>
</template>
<script lang="ts" setup>
import RoleApi from '@/pages/sys/role/role-api.ts'
import Page from '@/components/page/Page.vue'
import { elIcons } from '@/common/element/element.ts'
import RoleForm from '@/pages/sys/role/RoleForm.vue'
import { ElMessage } from 'element-plus'
import BindRes from '@/pages/sys/role/BindRes.vue'

const totalCount = ref(0)
const tableData = ref<RoleTypes.SearchRoleResult[]>([])
const searchForm = ref<RoleTypes.SearchRoleParam>({
  current: 1,
  size: 20,
})
const searching = ref(false)
const deling = ref(false)
const showSearchForm = ref(true)
const roleFormIns = useTemplateRef<InstanceType<typeof RoleForm>>('roleForm')
const bindResIns = useTemplateRef<InstanceType<typeof BindRes>>('bindRes')

function showDialog(data?: RoleTypes.SearchRoleResult) {
  roleFormIns.value?.open(data)
}

function delHandler({row}: { row: RoleTypes.SearchRoleResult }) {
  if (row.id == '1') {
    ElMessage.error('不能操作管理员')
    return
  }
  deling.value = true
  RoleApi.del([ row.id! ])
    .then(() => {
      ElMessage.success('删除成功')
      paging()
    })
    .finally(() => {
      deling.value = false
    })
}

function bindResHandler({row}: { row: RoleTypes.SearchRoleResult }) {
  bindResIns.value?.open(row.id!)
}

function modifyHandler({row}: { row: RoleTypes.SearchRoleResult }) {
  if (row.id == '1') {
    ElMessage.error('不能操作管理员')
    return
  }
  showDialog(row)
}

function addHandler() {
  showDialog()
}

function reset() {
  searchForm.value = {
    current: 1,
    size: 20,
  }
  paging()
}

function paging() {
  searching.value = true
  RoleApi.paging({
    ...searchForm.value,
  })
    .then(res => {
      totalCount.value = res.data?.total ?? 0
      tableData.value = res.data?.records ?? []
    })
    .finally(() => {
      searching.value = false
    })
}

onMounted(() => {
  paging()
})
</script>
<style lang="stylus" scoped>
.table-list {
  flex 1;
  margin 0 0 20px 0
  width 100%

  :deep(.table-header) {
    color #454C59

    th {
      background-color #EDF1F7
      font-weight 500
      position relative

      & > div {
        display flex
        gap 5px
        align-items center
      }

      &:not(:first-child) > div::before {
        position: absolute;
        top: 50%;
        left: 1px;
        width: 1px;
        background-color: #D3D7DE;
        transform: translateY(-50%);
        content: "";
        height 50%
      }
    }
  }

  :deep(.table-cell) {
    color #2F3540
  }

  .action-btn {
    width 100%
    display flex
    flex-wrap wrap

    & > button {
      margin 0
    }
  }
}

.tool-bar {
  display flex
  justify-content space-between
  margin 0 0 20px 0
}
</style>
